//////////////////////////////////////////
//       (c) Alexey V. Chubar           //
//                                      //
//   e-mail: alexey@krasair.scn.ru      //
//   url:    http://cbuilder.da.ru      //
//                                      //
//////////////////////////////////////////
//////////////////////////////////////////
// PLZ SEND me e-mail                   //
//   if you change component            //
//     and source code PLZ              //
//////////////////////////////////////////
//---------------------------------------------------------------------------
#ifndef WebServerH
#define WebServerH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ScktComp.hpp>
//---------------------------------------------------------------------------
// Define errors
#define ERR_UNKNOWN_METHOD 1
#define ERR_OK 0
// Define  method constants
#define METHOD_GET AnsiString("get")
// Define MimeTypes
#define HTML AnsiString("text/html")
// Define Errors messages
#define NOT_FOUND AnsiString("<html><body><h1><b>ERROR 404</b><br>Not found</h1><body></html>")
#define UNKNOWN_ERROR AnsiString("<html><body><h1><b>ERROR ???</b><br>Unknown error</h1><body></html>")
class PACKAGE TWebServer : public TServerSocket
{
private:
    AnsiString FMainDocument;
    void __fastcall SetMainDocument(AnsiString value);
    AnsiString __fastcall GetMainDocument();
    void __fastcall SetBasePath(AnsiString value);
    AnsiString __fastcall GetBasePath();
protected:
    AnsiString Method;
    bool KeepAlive;
    AnsiString HTTPVersion;
    AnsiString RequestDocument;
    TStringList* ServerReplyData;
    TStringList* ReplyHeader;
    TStringList* ReplyBody;
    AnsiString FBasePath;
    AnsiString MIMEType;
    bool __fastcall ParseHTTPHeader(AnsiString& HTTPHeader, AnsiString& Method);
    int __fastcall CreateReplyHTTPData();
    AnsiString __fastcall GetFileMIMEType();
    bool __fastcall SendStreamToClient(TCustomWinSocket* Socket);
public:
    int ResourceSize;
    int ErrorCode;
        __fastcall TWebServer(TComponent* Owner);
    bool __fastcall ExecuteServerReply(TCustomWinSocket* ClientSocket);
    __fastcall ~TWebServer();
__published:
   __property AnsiString MainDocument  = { read = GetMainDocument, write = SetMainDocument};
    __property AnsiString BasePath  = { read = GetBasePath, write = SetBasePath };
   };
//---------------------------------------------------------------------------
#endif
